#include <stdio.h>
#include <stdlib.h> 
#include <pthread.h>
#include <semaphore.h>
#include <math.h>
#include <time.h>

#define NPRODUTORES 1
#define NCONSUMIDORES 1

#define TAMBUFFER 5

//buffer
int buffer[TAMBUFFER];
int count = 0, in = 0, out = 0;
int consumidos = 0;

int fim = 0;

//semáforos para controlar o uso do buffer
sem_t semprod, semcons;     
sem_t em;     

// Séries temporais
int tamanhoBuffer[200];
double tempoEspera[200];
int indexVetorTamanhoBuffer = 0;


int ehPrimo ( long unsigned int n ) {
  int i ;
  if ( n <= 1) return 0;
  if ( n == 2) return 1;
  if ( n %2 == 0) return 0;
  
  for ( i = 3; i < sqrt ( n) +1; i += 2) {
    if ( n %i == 0) return 0;
  }
  return 1;
}


void *prod (void *threadid) {
  int *tid = (int*) threadid;
  int i, valueBuffer;
  
  for(i = 0; i < 100 ; i++) {
    // Produzir um elemento

    clock_t start, end;
    double cpu_time_used;
    start = clock();

    //Aguarda o buffer ter espaço
    sem_wait(&semprod);

    
    sem_wait(&em);
    buffer[in] = valueBuffer = 3 * i*i + 7*i;
    in = (in + 1) % TAMBUFFER;
    count++;

    end = clock();
    cpu_time_used = ((double) (end - start)) / CLOCKS_PER_SEC;

    tamanhoBuffer[indexVetorTamanhoBuffer] = count;
    tempoEspera[indexVetorTamanhoBuffer] = cpu_time_used;
    indexVetorTamanhoBuffer++;

    printf("[Produtor %d] item %d inserido. Tamanho do buffer: %d\n", *tid, valueBuffer, count);

    //Permite o consumo de mais um item no buffer
    sem_post(&semcons);
    
    sem_post(&em);
  }

  pthread_exit(NULL);
}

void *cons (void *threadid) {
  int *tid = (int*) threadid;
  int valueBuffer;
  int primo;

  while(fim ==
(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)


    clock_t st
(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)


    double cpu
(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)


    start = cl
(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)



    //Aguarda 
(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)


    sem_wait(&
(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)



    if(fim == 
(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)


        break;
(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)


    }

    sem_wait(&em);
    valueBuffer = buffer[out % TAMBUFFER];
    out = (out + 1) % TAMBUFFER;

    sem_post(&em);
    primo = ehPrimo(valueBuffer);
    sem_wait(&em);

(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)



(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)



(1, 1)
(2, 2)
(3, 3)
(4, 4)
(5, 5)
(6, 4)
(7, 3)
(8, 2)
(9, 1)
(10, 0)
(11, 1)
(12, 2)
(13, 3)
(14, 4)
(15, 5)
(16, 4)
(17, 3)
(18, 4)
(19, 5)
(20, 4)
(21, 3)
(22, 2)
(23, 1)
(24, 0)
(25, 1)
(26, 2)
(27, 3)
(28, 4)
(29, 3)
(30, 2)
(31, 1)
(32, 2)
(33, 3)
(34, 4)
(35, 5)
(36, 4)
(37, 3)
(38, 2)
(39, 1)
(40, 0)
(41, 1)
(42, 2)
(43, 3)
(44, 4)
(45, 5)
(46, 4)
(47, 3)
(48, 2)
(49, 1)
(50, 0)
(51, 1)
(52, 2)
(53, 3)
(54, 4)
(55, 5)
(56, 4)
(57, 3)
(58, 2)
(59, 3)
(60, 4)
(61, 5)
(62, 4)
(63, 3)
(64, 4)
(65, 5)
(66, 4)
(67, 3)
(68, 4)
(69, 5)
(70, 4)
(71, 3)
(72, 4)
(73, 5)
(74, 4)
(75, 3)
(76, 2)
(77, 1)
(78, 0)
(79, 1)
(80, 2)
(81, 3)
(82, 4)
(83, 5)
(84, 4)
(85, 3)
(86, 4)
(87, 5)
(88, 4)
(89, 3)
(90, 4)
(91, 5)
(92, 4)
(93, 3)
(94, 4)
(95, 5)
(96, 4)
(97, 3)
(98, 4)
(99, 5)
(100, 4)
(101, 3)
(102, 4)
(103, 5)
(104, 4)
(105, 3)
(106, 4)
(107, 5)
(108, 4)
(109, 3)
(110, 2)
(111, 1)
(112, 2)
(113, 3)
(114, 4)
(115, 5)
(116, 4)
(117, 3)
(118, 2)
(119, 3)
(120, 4)
(121, 5)
(122, 4)
(123, 3)
(124, 2)
(125, 3)
(126, 4)
(127, 5)
(128, 4)
(129, 3)
(130, 2)
(131, 1)
(132, 2)
(133, 3)
(134, 4)
(135, 5)
(136, 4)
(137, 3)
(138, 4)
(139, 5)
(140, 4)
(141, 3)
(142, 2)
(143, 1)
(144, 0)
(145, 1)
(146, 2)
(147, 3)
(148, 4)
(149, 5)
(150, 4)
(151, 3)
(152, 2)
(153, 1)
(154, 0)
(155, 1)
(156, 2)
(157, 3)
(158, 4)
(159, 5)
(160, 4)
(161, 3)
(162, 2)
(163, 3)
(164, 4)
(165, 5)
(166, 4)
(167, 3)
(168, 4)
(169, 5)
(170, 4)
(171, 3)
(172, 2)
(173, 3)
(174, 4)
(175, 5)
(176, 4)
(177, 3)
(178, 2)
(179, 3)
(180, 2)
(181, 3)
(182, 4)
(183, 5)
(184, 4)
(185, 3)
(186, 4)
(187, 5)
(188, 4)
(189, 3)
(190, 4)
(191, 5)
(192, 4)
(193, 3)
(194, 4)
(195, 5)
(196, 4)
(197, 3)
(198, 2)
(199, 1)
(200, 0)


    end = clock();
    cpu_time_used = ((double) (end - start)) / CLOCKS_PER_SEC;

    tamanhoBuffer[indexVetorTamanhoBuffer] = count;
    tempoEspera[indexVetorTamanhoBuffer] = cpu_time_used;
    indexVetorTamanhoBuffer++;

    consumidos++;
    printf("[Consumidor %d] item %d removido (%s). Tamanho do buffer: %d. Itens consumidos: %d\n", *tid, valueBuffer, primo? "Primo" : "Não primo", count, consumidos);
    
    //Permite a produção de mais um item no buffer
    sem_post(&semprod);
    
    sem_post(&em);
  }


  pthread_exit(NULL);
}




//Função principal
int main(int argc, char *argv[]) {
  pthread_t tid_p[NPRODUTORES];
  pthread_t tid_c[NCONSUMIDORES];
  
  int *id_p[NPRODUTORES], *id_c[NCONSUMIDORES], t;

  for (t=0; t<NPRODUTORES; t++) {
    if ((id_p[t] = (int*) malloc(sizeof(int))) == NULL) {
       pthread_exit(NULL); return 1;
    }
    *id_p[t] = t+1;
  }

  for (t=0; t<NCONSUMIDORES; t++) {
    if ((id_c[t] = (int*) malloc(sizeof(int))) == NULL) {
       pthread_exit(NULL); return 1;
    }
    *id_c[t] = t+1;
  }

  //Inicia os semáforos de controle do buffer (buffer vazio)
  sem_init(&semprod, 0, TAMBUFFER);
  sem_init(&semcons, 0, 0);

  sem_init(&em, 0, 1);

  //Inicializa as threads
  for (t=0; t<NPRODUTORES; t++) {
    if (pthread_create(&tid_p[t], NULL, prod, (void *)id_p[t])) { printf("--ERRO: pthread_create()\n"); exit(-1); }
  }

  for (t=0; t<NCONSUMIDORES; t++) {
    if (pthread_create(&tid_c[t], NULL, cons, (void *)id_c[t])) { printf("--ERRO: pthread_create()\n"); exit(-1); }
  }

  for (t=0; t<NPRODUTORES; t++) {
    if (pthread_join(tid_p[t], NULL)) {
         printf("--ERRO: pthread_join() \n"); exit(-1); 
    } 
  }

  // Encerra a thread consumidora
  fim = 1;
  sem_post(&semcons);

  for (t=0; t<NCONSUMIDORES; t++) {
    if (pthread_join(tid_c[t], NULL)) {
         printf("--ERRO: pthread_join() \n"); exit(-1); 
    } 
  }

  printf("Estatísticas: \n\n\n\n");
  printf("Evolução do tamanho do buffer: (Id do snapshot, tamanho do buffer)\n\n");
  for(t = 0; t < indexVetorTamanhoBuffer; t++) {
      printf("(%d, %d)\n", (t+1), tamanhoBuffer[t]);
  }

  printf("\n\nTempo de espera entre primeira tentativa e sucesso na entrada para produção / consumo: (Id do snapshot, tempo)\n\n");
  for(t = 0; t < indexVetorTamanhoBuffer; t++) {
      printf("(%d, %f)\n", (t+1), tempoEspera[t]);
  }

  pthread_exit(NULL);
}
